clear all;

c=1;
k=5;

N=2^k-1;

P=sparse(zeros(N));
A=sparse(zeros(N^2));
B=zeros(N^2,1);

for i=1:N
    for j=1:N
       
        H=sub2ind(size(P),i,j);
        A(H,H)=-4-1/2*c*2^(-2*k);
        
        if i>1
            
            K=sub2ind(size(P),i-1,j);
            A(H,K)=1+c/12*2^(-2*k);
        end
        
        if i<N
            
            K=sub2ind(size(P),i+1,j);
            A(H,K)=1+c/12*2^(-2*k);
        end
        
        if j>1
            
            K=sub2ind(size(P),i,j-1);
            A(H,K)=1-c/12*2^(-2*k);
        end
        
         if j<N
            
            K=sub2ind(size(P),i,j+1);
            A(H,K)=1-c/12*2^(-2*k);
        end
        
        if i>1 & j>1
            
            K=sub2ind(size(P),i-1,j-1);
            A(H,K)=-c/12*2^(-2*k);
        end
        
          
        if i<N & j<N
            
            K=sub2ind(size(P),i+1,j+1);
            A(H,K)=-c/12*2^(-2*k);
        end
        
    end
end

for i=1:N
    for j=1:N
       
        H=sub2ind(size(P),i,j);
        B(H)=1/2*f(2^(-k)*i,1-2^(-k)*j,c);  
        
        if i>1
            
            K=sub2ind(size(P),i-1,j);
            B(H)= B(H)+ 3/24*f(2^(-k)*(i-1),1-2^(-k)*j,c);
        end
        
        if i<N
            
            K=sub2ind(size(P),i+1,j);
            B(H)= B(H)+ 3/24*f(2^(-k)*(i+1),1-2^(-k)*j,c);
        end
        
        if j>1
            
            K=sub2ind(size(P),i,j-1);
            B(H)= B(H)+ 3/24*f(2^(-k)*i,1-2^(-k)*(j-1),c);         
        end
        
         if j<N
            
            K=sub2ind(size(P),i,j+1);
            B(H)= B(H)+ 3/24*f(2^(-k)*i,1-2^(-k)*(j+1),c);
        end
        
        if i>1 & j>1
            
            K=sub2ind(size(P),i-1,j-1);
            B(H)= B(H)+ 3/24*f(2^(-k)*(i-1),1-2^(-k)*(j-1),c);
        end
        
          
        if i<N & j<N
            
            K=sub2ind(size(P),i+1,j+1);
            B(H)= B(H)+ 3/24*f(2^(-k)*(i+1),1-2^(-k)*(j+1),c);
        end
        
    end
end

B=B*2^(-2*k);

L=A\B;

U=reshape(L,N,N);

x=linspace(2^(-k),1-2^(-k),N);
y=linspace(2^(-k),1-2^(-k),N);

[X,Y]=meshgrid(x,y);

surf(X,Y,U)